function [xx dual_vec] = Newton_loss_sq(ploss,dloss,ytr,As,eta,q,loss_name,scale,rho,b_Hessian)
%(P) min ploss(As*x) + 1/(2*eta)||x - eta*q||^2
%(D) min dloss(rho) + eta/2*||A'*rho||^2 - eta (A'*rho)'*q;

% nscale = 1;
% etad = eta;
% 
% if type == 1
%     etad = eta;             
%     x0 = zz - eta*yy;
% elseif type == 4
%     etad = eta^(3.5/2);             
%     x0 = xx;
% end;

if ~exist('rho','var') || isempty(rho)
    rho = -ytr/2;
end;

if ~exist('b_Hessian','var')
    b_Hessian = 1;
end;

for ii=1:1000      
    if b_Hessian
        [fdloss grad Hessian hmin] = dloss(rho,ytr);
    else
        [fdloss grad] = dloss(rho,ytr);
    end;
    
    Arho = As'*rho;
    fdual = fdloss + (eta/2)*sum((Arho).^2) - eta*(Arho'*q);
    grad = grad + eta*As*(Arho - q);

    if b_Hessian
        Hessian = Hessian + eta*As*As';
        updir = - Hessian\grad;
    else
        updir = - grad;
    end;

    old_fdual = fdual;
    old_rho = rho;
    rho = rho + updir;

    if  strcmp(loss_name,'logit') || strcmp(loss_name,'shinge')
        if strcmp(loss_name,'logit')
            shrinkfact = 0.98;
        else
            shrinkfact = 0.999; %shinge͂̕@ł͉ȂD񎟌vgׂD
        end;
      old_yrho = old_rho.*(-ytr);
      yrho = (rho).*(-ytr);
      if any(yrho >= scale | yrho <= 0)
          yd = (-ytr).*updir;
          ss = min([(scale-old_yrho(yd>0))./yd(yd>0);(-old_yrho(yd<0)./(yd(yd<0)))])*shrinkfact;
          updir = updir*ss;
          rho = old_rho + updir;
      end;
    end;

    steplen = 1;
    while fdual > old_fdual + steplen*0.1*(updir'*grad) && (steplen > 0)             
        rho = old_rho + updir*steplen;
        [fdloss] = dloss(rho,ytr);      
        Arho = As'*rho;
        fdual = fdloss + (eta/2)*sum((Arho).^2) - eta*(Arho'*q);
        steplen = steplen/2;        
    end;
    xtmp = eta*(- Arho + q);
    [fploss] = ploss(As*xtmp, ytr);
    fprimal =  fploss + sum((xtmp-eta*q).^2)/(2*eta);%(xtmp-eta*q)'*(xtmp-eta*q)/(2*eta); %+ lambda*sum(abs(xtmp))
    fprintf(1,'  primal:%g, dual:%g, gap:%g, step_len:%g\n',fprimal,-fdual,(fprimal+fdual)/fprimal,steplen);

    if abs(fprimal+fdual)/abs(fprimal)<0.000001 || (abs(fprimal) < 0.0001 && abs(fprimal+fdual)<0.000001) %0.000001 || (abs(fprimal) < 0.0001 && abs(fprimal+fdual)<0.000001)
        break;
    end;      
end;
xx = xtmp;
dual_vec = rho;