function v = foglasso_prox(x,lambda,G,varargin)

opt=propertylist2struct(varargin{:});
opt=set_defaults(opt,'style',1);

MaxIter = 100000;
dual_gap = 1e-8;

signx = sign(x);

u = abs(x);

Y = zeros(size(G));


for step = 1:MaxIter    
    [fval,grad] = omega(Y,u,G);
    style = 1;
    if style == 1
        if step == 1
            dir = -grad;
        else
            beta = vect(grad)'*(vect(grad)-vect(old_grad))/norm(vect(old_grad))^2;
            dir = - grad + beta*old_dir;
        end;
    else
        dir = -grad;
    end;

    old_dir = dir;
    old_grad = grad;
    
    steplen = 1; 
    old_fval = fval;
    old_Y = Y;
    Y = old_Y + dir*steplen;
    [fval] = omega(Y,u,G);
    
    %search stepsize by Armijo's rule
    while fval > old_fval %+ steplen*0.1*(vect(dir)'*vect(grad)) && (steplen > 0)             
        steplen = steplen/2; 
        Y = old_Y + dir*steplen;        
        fval = omega(Y,u,G);
    end;
    %Y = Y.*G;
    normY = sqrt(sum(Y.^2,1));
    Ipos = (normY > 0);
    Y(:,Ipos) = Y(:,Ipos)./(ones(size(Y,1),1)*max(normY(Ipos)/lambda,1)); %projection
    Y = Y.*G;
    fval = omega(Y,u,G);    
    
    yy = sum(Y,2);
    vtill= max(u-yy,0);
    regval = greg(vtill,G);
    gap = (lambda*regval - sum(vtill'*Y));
    disp(sprintf('  [[%d]] fval:%g, gap:%g',step,fval,gap));
    disp(sprintf('         fval:%g old_fval:%g diff:%g',fval,old_fval,abs(old_fval - fval)/abs(fval)));
    
    if gap <= dual_gap %|| (abs(old_fval - fval)/abs(fval) <= 1e-19)
        break;
    end;
end;

v = signx.*vtill;

function [val,grad] = omega(Y,u,G)
yy = sum(Y,2);
myu = max(u-yy,0);
val = -0.5*sum((myu - u).^2) - myu'*yy;
grad = -(myu*ones(1,size(Y,2))).*G;


function vv = vect(VV)
vv=reshape(VV,numel(VV),1);

function regval = greg(vv,G)
regval = sum(sqrt((vv.^2)'*G));