function [floss, gloss, Hessian, hmin]=loss_shd_scale(xin,yin, scale)
%smoothed hinge

mm = length(xin);
zy = xin.*yin;

if nargin > 2
    zy = zy/scale;
end;

%I = find(-1 <= zy & zy <= 0);
%floss = sum(0.5*(zy(I) + 1).^2 - 0.5);
%gloss = nan*ones(mm,1);
%gloss(I) = yin(I).*(zy(I)+1);

floss = sum(0.5*(zy + 1).^2 - 0.5);
gloss = yin.*(zy+1);

if nargout<=2
  if nargin > 2
      floss = floss*scale;
  end;
  varargout={floss, gloss};

else    
  Hessian = spdiags(ones(mm,1),0,mm,mm);
  hmin = 1;
  if nargin > 2
      floss = floss*scale;
      Hessian = Hessian/scale;
      hmin = hmin/scale;
  end;
  varargout={floss, gloss, Hessian, hmin};
end

