function [floss, gloss]=loss_shp_scale(xin,yin, scale)
%smoothed hinge

zy      = xin.*yin;

Indz = (zy >= 1);
Indn = (zy <= 0);
Indzn = (zy >0 & zy < 1);

floss = sum(0.5 - zy(Indn)) + sum(0.5*(1-zy(Indzn)).^2);

gloss = zeros(length(zy),1);
gloss(Indz) = 0;
gloss(Indn) = - yin(Indn);
gloss(Indzn) = yin(Indzn).*(zy(Indzn) - 1);

if nargin > 2
    floss = floss*scale;
    gloss = gloss*scale;
end;

